#
# Copyright (c) 2008-2018 Thierry Florac <tflorac AT ulthar.net>
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#

__docformat__ = 'restructuredtext'

from z3c.form.interfaces import INPUT_MODE
from z3c.form.widget import FieldWidget

from pyams_form.interfaces import IFormLayer
from pyams_form.widget import Select2Widget, widgettemplate_config

from pyams_portal import _


@widgettemplate_config(mode=INPUT_MODE, template='templates/renderer-input.pt', layer=IFormLayer)
class PortletRendererWidget(Select2Widget):
    """Portlet renderer selection widget"""

    hint = _("Edit renderer properties")

    @property
    def show_renderer_properties(self):
        renderer = self.context.get_renderer(self.request)
        return (renderer is not None) and (renderer.settings_interface is not None)

    @property
    def renderer_properties_hint(self):
        return self.request.localizer.translate(self.hint)


def PortletRendererFieldWidget(field, request):
    return FieldWidget(field, PortletRendererWidget(request))
